unit UnitFormMain;

{===============================================================================
 Demo Web Service Part 3

 For Blaise Pascal Magazine 2021
 https://www.blaisepascalmagazine.eu/

 Author: Danny Wind (https://dannywind.nl)
 License: Creative Commons CC-BY
===============================================================================}

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, System.Net.URLClient,
  System.Net.HttpClient, System.Net.HttpClientComponent, Vcl.ExtCtrls,
  Vcl.StdCtrls, Vcl.ToolWin, Vcl.ComCtrls;

type
  TFormMain = class(TForm)
    NetHTTPClient: TNetHTTPClient;
    NetHTTPRequest: TNetHTTPRequest;
    EditURL: TEdit;
    ButtonGET: TButton;
    PanelTop: TPanel;
    MemoResponse: TMemo;
    MemoBody: TMemo;
    GridPanelHTTP: TGridPanel;
    ButtonPOST: TButton;
    ButtonPUT: TButton;
    ButtonDELETE: TButton;
    procedure NetHTTPRequestRequestCompleted(const Sender: TObject;
      const AResponse: IHTTPResponse);
    procedure ButtonGETClick(Sender: TObject);
    procedure ButtonPUTClick(Sender: TObject);
    procedure ButtonPOSTClick(Sender: TObject);
    procedure ButtonDELETEClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormMain: TFormMain;

implementation

{$R *.dfm}

uses
  System.JSON;

procedure TFormMain.ButtonDELETEClick(Sender: TObject);
begin
  NetHTTPRequest.Delete(EditURL.Text, nil, nil);
end;

procedure TFormMain.ButtonGETClick(Sender: TObject);
begin
  NetHTTPRequest.MethodString := 'GET';
  NetHTTPRequest.URL := EditURL.Text;
  NetHTTPRequest.Execute();
end;

procedure TFormMain.ButtonPOSTClick(Sender: TObject);
var
  lContentStream: TStringStream;
  lJSONString: TJSONString;
begin
  { Encode string stream as UTF8 }
  lJSONString := TJSONString.Create(MemoBody.Lines.Text);
  lContentStream := TStringStream.Create(lJSONString.ToJSON([TJSONAncestor.TJSONOutputOption.EncodeBelow32]), TEncoding.UTF8);
  lJSONString.Free;
  lContentStream.Seek(0, TSeekOrigin.soBeginning);
  NetHTTPRequest.Post(EditURL.Text, lContentStream, nil, nil);
end;

procedure TFormMain.ButtonPUTClick(Sender: TObject);
var
  lContentStream: TStringStream;
  lJSONString: TJSONString;
begin
  { Encode string stream as UTF8 }
  lJSONString := TJSONString.Create(MemoBody.Lines.Text);
  lContentStream := TStringStream.Create(lJSONString.ToJSON([TJSONAncestor.TJSONOutputOption.EncodeBelow32]), TEncoding.UTF8);
  lJSONString.Free;
  lContentStream.Seek(0, TSeekOrigin.soBeginning);
  NetHTTPRequest.Put(EditURL.Text, lContentStream, nil, nil);
end;

procedure TFormMain.NetHTTPRequestRequestCompleted(const Sender: TObject;
  const AResponse: IHTTPResponse);
begin
  MemoResponse.Text := AResponse.ContentAsString;
end;

end.
